<template>
  <v-toolbar
    density="compact"
    floating
    width="100%"
    :title="currentChat.titulo"
  >
    <template v-slot:prepend>
      <v-btn
        @click="emit('home')"
        icon="mdi-arrow-left-top"
        class="ma-0 pa-0"
      />
    </template>
    <template v-slot:append v-if="props.nivelUsuario != 'usuario'">
      <v-btn
        @click="broadCast = true"
        icon="mdi-bullhorn-variant-outline"
        class="ma-0 pa-0"
      />
    </template>
  </v-toolbar>
  <v-divider class="mb-2" />
  <perfect-scrollbar :style="{ height: '90vh' }">
    <Broadcast v-if="broadCast" :materiaId="currentChat.chatId" />
    <v-row v-else class="ma-0 pa-0" :style="{ overflow: 'hidden' }">
      <h1 v-if="currentChat.mensajes.length == 0">No Hay Chats</h1>
      <v-col
        v-for="(mensaje, index) in currentChat.mensajes"
        class="ma-0 mt-1 pa-0"
        width="90vw"
        :id="'mensaje-' + index"
      >
        <v-card
          :color="getColor(mensaje.prioridad)"
          :title="mensaje.titulo"
          width="90vw"
          class="ma-0 ml-3 mr-3 pa-1"
        >
          <v-card-subtitle class="text-wrap">
            {{ mensaje.emisor }}:
            <v-chip>{{ getTimeString(mensaje.timestamp) }}</v-chip>
          </v-card-subtitle>
          {{ mensaje.contenido }}
        </v-card>
      </v-col>
    </v-row>
  </perfect-scrollbar>
</template>

<script setup lang="ts">
import { PerfectScrollbar } from "vue3-perfect-scrollbar";
import { PropType, onMounted, ref } from "vue";
import { Chat } from "../../data/models/Chat";
import { ChatRoom } from "../../data/models/ChatRoom";
import { backendCollector } from "../../data/collectors/backendCollector";
import { DateTime } from "luxon";
import Broadcast from "./ChatRoom/Broadcast.vue";
import { Niveles } from "../../data/providers/ServerProvider";
const props = defineProps({
  selectedChat: {
    required: true,
    type: Object as PropType<Chat>,
  },
  nivelUsuario: {
    required: true,
    type: Object as PropType<Niveles>,
  },
});
const emit = defineEmits<{
  (event: "home"): void;
}>();

const broadCast = ref(false);

const fetched = await backendCollector.getChatRoom(props.selectedChat);
if (!fetched.success) {
  // hacer algo
}
const currentChat: ChatRoom = fetched.data!;

onMounted(() => {
  const element = document.getElementById(
    `mensaje-${currentChat.mensajes.length - 1}`
  );
  if (element == null) return;
  element.scrollIntoView(true);
});

function getColor(prioridad: ChatRoom["mensajes"][number]["prioridad"]) {
  switch (prioridad) {
    case "normal":
      return "blue";
    case "alta":
      return "orange";
    case "emergencia":
      return "red";
  }
}
function getTimeString(timeStamp: string) {
  const fecha = DateTime.fromISO(timeStamp).setLocale("par");
  return fecha.toFormat("HH:mm dd-MM-yy");
}
</script>
